#!/bin/sh

WEBSERVICE=$(grep "PreShowMusicService=1" /usr/share/CineDigitalManager/config.properties | wc -l)
PSMBI=$(grep '^PreShowMusicBroadcastInterface' /usr/share/CineDigitalManager/config.properties|cut -d= -f 2|tr -d '[:cntrl:]' )
PSMBA=$(grep '^PreShowMusicBroadcastAddress' /usr/share/CineDigitalManager/config.properties|cut -d= -f 2|tr -d '[:cntrl:]' )

unset DISPLAY
export Description="CineDigitalManager PreShowMusicService"
export javapath=$(which java)
export pidfile="/var/run/CineDigitalManagerPreShowMusicService.pid"
export cdmwsdcommand="$javapath -Xmx1024m -cp /usr/share/CineDigitalManager/CineDigitalManager-3.0.06.jar fr.cinedigitalservicetms.tms.musiqueAmbianceService.MusiqueAmbianceParDefaut /usr/share/CineDigitalManager"

if [ $WEBSERVICE -ne 1 ]; then
    #echo "Service is not enabled (/usr/share/CineDigitalManager/config.properties file must contain PreShowMusicService=1)"
    sleep 3600
    exit 0
fi

if [ "xxx$PSMBA" = "xxx" ]; then
    PSMBA=224.1.2.3
fi

if [ "xxx$PSMBI" = "xxx" ]; then
    PSMBI=eth0
fi


myjavapid() {
    if [ -e "$pidfile" ]; then
        if pidof java | tr ' ' '\n' | grep -w $(cat $pidfile); then
            return 0
        fi
    fi
    return 1
}


if [ -e $pidfile ] ; then
    PID=$(myjavapid) || true
    if [ -n "$PID" ]; then
        echo "${Description} is already running (pid $PID)"
        exit 0
    else
        echo "\nOops: Looks like ${Description} crashed! \n\n"
        rm -f $pidfile
    fi
fi

route del -host $PSMBA 2>/dev/null


STOP=0
while [ $STOP -lt 10 ]; do
    if [ -f /sys/class/net/$PSMBI/operstate ]; then
        STATE=$(cat /sys/class/net/$PSMBI/operstate)
    else
        STATE=down
    fi
    if [ "xxx$STATE" = "xxxup" ]; then
        route add -host $PSMBA dev $PSMBI
        STOP=99
    else 
        sleep 1
        STOP=$(expr $STOP + 1)
    fi
done

if [ $STOP -eq 99 ]; then

    $cdmwsdcommand &
    PID=$!
    # we make sure that java had enough time to start
    sleep 3

    echo "${Description} is now running (pid $PID)"

    if [ "xxx$PID" != "xxx" ]; then
        renice -5 -p $PID
    fi
    echo $PID > $pidfile
    wait
fi

# si on arrive la, c'est que le processus est mort.
# on sleep pour ne pas agresser init aui va finir par nous killer
sleep 60
